// SETTINGS
const iframe_id = "xmp_iframe";
const listbox_id = "xmp_listbox";
const dialog_id = "xmp_dialog";
const preference_branch = ""; //renseign it only if you want to acces the mozilla native prefs

// INITIALIZE
var myOManager;
var myOService;
const prefServ = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(preference_branch);
function initOManager()
	{
	myOService = new option_service(preference_branch);
	myOManager = new option_manager(myOService);
	myOManager.initPage();
	document.getElementById(listbox_id).addEventListener('select',handleEvent,true);
	document.getElementById(dialog_id).addEventListener('dialogaccept',handleEvent,true);
	document.getElementById(dialog_id).setAttribute("onload", "");
	document.getElementById(dialog_id).addEventListener('load',handleEvent,true);
	}

function handleEvent(hEvent)
	{
	switch (hEvent.type)
		{
		case "dialogaccept" :
		myOManager.closeDialog();
		break;
		case "load" :
		myOManager = new option_manager(myOService);
		myOManager.initPage();
		break;
		case "select" :
		myOManager.changePage();
		break;
		default :
		alert("Unexpected event : " + hEvent.type);
		}
	}

// OPTION_MANAGER OBJECT
function option_manager(optionBuffer)
	{
	this.iframe = document.getElementById(iframe_id);
	this.page = this.iframe.contentDocument; //window.frames[iframe_id].document
	this.listbox = document.getElementById(listbox_id);
	this.dialog = document.getElementById(dialog_id);
	this.textboxList = new Array();
	this.checkboxList = new Array();
	this.radiogroupList = new Array();
	this.listboxList = new Array();
	this.menulistList = new Array();
	this.optionBuffer = optionBuffer;
	};
	option_manager.prototype.changePage = function ()
		{
		this.storePage();
		this.iframe.setAttribute("src", this.listbox.selectedItem.getAttribute("value"));
		}
	option_manager.prototype.closeDialog = function ()
		{
		this.storePage();
		this.optionBuffer.saveOptions();
		}
	option_manager.prototype.initPage = function ()
		{
		// TEXTBOX
		this.textboxList = this.page.getElementsByTagName("textbox");
		for(var i=0; i<this.textboxList.length; i++)
			{
			this.textboxList[i].value = this.optionBuffer.getCharOption(this.textboxList[i].getAttribute("id"));
			}
		// CHECKBOX
		this.checkboxList = this.page.getElementsByTagName("checkbox");
		for(var i=0; i<this.checkboxList.length; i++)
			{
			alert(this.optionBuffer.getBoolOption(this.checkboxList[i].getAttribute("id")));
			this.checkboxList[i].checked = this.optionBuffer.getBoolOption(this.checkboxList[i].getAttribute("id")); //setAttribute("checked", this.optionBuffer.getBoolOption(this.checkboxList[i].getAttribute("id")));
			}
		// RADIOGROUP
		this.radiogroupList = this.page.getElementsByTagName("radiogroup");
		for(var i=0; i<this.radiogroupList.length; i++)
			{
			currentRadio = this.page.getElementsByAttribute("value", this.optionBuffer.getCharOption(this.radiogroupList[i].getAttribute("id")));
			if(currentRadio[0])
				this.radiogroupList[i].selectedItem = currentRadio[0];
			}
		// LISTBOX
		this.listboxList = this.page.getElementsByTagName("listbox");
		for(var i=0; i<this.listboxList.length; i++)
			{
			if(this.optionBuffer.getCharOption(this.listboxList[i].getAttribute("id")))
				{
				currentValues = this.optionBuffer.getCharOption(this.listboxList[i].getAttribute("id")).split('#');
				for(var j=0; j<currentValues.length-1; j++)
					{
					currentListitem = this.page.getElementsByAttribute("value", currentValues[j])
					if(!currentListitem[0].selected)
					this.listboxList[i].toggleItemSelection(currentListitem[0]);
					}
				}
			}
		// MENULIST
		this.menulistList = this.page.getElementsByTagName("menulist");
		for(var i=0; i<this.menulistList.length; i++)
			{
			currentMenuitem = this.page.getElementsByAttribute("value", this.optionBuffer.getCharOption(this.menulistList[i].getAttribute("id")));
			if(currentMenuitem[0])
				this.menulistList[i].selectedItem = currentMenuitem[0];
			}
		}
	option_manager.prototype.storePage = function ()
		{
		// TEXTBOX
		for(var i=0; i<this.textboxList.length; i++)
			{
			this.optionBuffer.setCharOption(this.textboxList[i].getAttribute("id"), this.textboxList[i].value);
			}
		// CHECKBOX
		for(var i=0; i<this.checkboxList.length; i++)
			{
			this.optionBuffer.setBoolOption(this.checkboxList[i].getAttribute("id"), this.checkboxList[i].checked);
			}
		// RADIOGROUP
		for(var i=0; i<this.radiogroupList.length; i++)
			{
			this.optionBuffer.setCharOption(this.radiogroupList[i].getAttribute("id"), this.radiogroupList[i].selectedItem.value);
			}
		// LISTBOX
		for(var i=0; i<this.listboxList.length; i++)
			{
			var currentValue = "";
			for(var j=0; j<this.listboxList[i].selectedCount; j++)
				{
				currentValue += this.listboxList[i].getSelectedItem(j).value + "#";
				}
			this.optionBuffer.setCharOption(this.listboxList[i].getAttribute("id"), currentValue);
			}
		// MENULIST
		for(var i=0; i<this.menulistList.length; i++)
			{
			this.optionBuffer.setCharOption(this.menulistList[i].getAttribute("id"), this.menulistList[i].selectedItem.value);
			}
		}

function option_service(prefBranch)
	{
	this.optionValue = new Array();
	this.optionValue['char'] = new Array();
	this.optionValue['bool'] = new Array();
	this.optionName = new Array();
	this.optionName['char'] = new Array();
	this.optionName['bool'] = new Array();
	};
	option_service.prototype.setCharOption = function (name, value)
		{
		this.optionName['char'][this.optionName['char'].length] = name;
		this.optionValue['char'][name] = value;
		}
	option_service.prototype.setBoolOption = function (name, value)
		{
		this.optionName['bool'][this.optionName['bool'].length] = name;
		this.optionValue['bool'][name] = value;
		}
	option_service.prototype.getCharOption = function (name)
		{
		if(this.optionValue['char'][name])
			{
			return this.optionValue['char'][name];
			}
		else if(prefServ.prefHasUserValue(name))
			{
			this.optionName['char'][this.optionName['char'].length] = name;
			return this.optionValue['char'][name] = prefServ.getCharPref(name);
			}
		else
			{
			return "";
			}
		}
	option_service.prototype.getBoolOption = function (name)
		{
		if(this.optionValue['bool'][name])
			{
			return this.optionValue['bool'][name];
			}
		else if(prefServ.prefHasUserValue(name))
			{
			this.optionName['bool'][this.optionName['bool'].length] = name;
			return this.optionValue['bool'][name] = prefServ.getBoolPref(name);
			}
		else
			{
			return false;
			}
		}
	option_service.prototype.saveOptions = function ()
		{
		for(var i=0; i<this.optionName['char'].length; i++)
			{
			prefServ.setCharPref(this.optionName['char'][i], this.optionValue['char'][this.optionName['char'][i]]);
			}
		for(var i=0; i<this.optionName['bool'].length; i++)
			{
			prefServ.setBoolPref(this.optionName['bool'][i], this.optionValue['bool'][this.optionName['bool'][i]]);
			}
		}
	option_service.prototype.resetOptions = function ()
		{
		this.prefServ.resetUserPrefs();
		}
